URLDecoder (Java Platform SE 8 )
Keywords: java.net.URLDecoder class
Date: 2016-07-28

compact1, compact2, compact3
java.net

## Class URLDecoder

- java.lang.Object
- - java.net.URLDecoder

-     public class URLDecoder
      extends Object

  Utility class for HTML form decoding. This class contains static methods for decoding a String from the `application/x-www-form-urlencoded` MIME format.

  The conversion process is the reverse of that used by the URLEncoder class. It is assumed that all characters in the encoded string are one of the following: "`a`" through "`z`", "`A`" through "`Z`", "`0`" through "`9`", and "`-`", "`_`", "`.`", and "`*`". The character "`%`" is allowed but is interpreted as the start of a special escaped sequence.

  The following rules are applied in the conversion:

  - The alphanumeric characters "`a`" through "`z`", "`A`" through "`Z`" and "`0`" through "`9`" remain the same.
  - The special characters "`.`", "`-`", "`*`", and "`_`" remain the same.
  - The plus sign "`+`" is converted into a space character " " .
  - A sequence of the form "`%xy`" will be treated as representing a byte where xy is the two-digit hexadecimal representation of the 8 bits. Then, all substrings that contain one or more of these byte sequences consecutively will be replaced by the character(s) whose encoding would result in those consecutive bytes. The encoding scheme used to decode these characters may be specified, or if unspecified, the default encoding of the platform will be used.

  There are two possible ways in which this decoder could deal with illegal strings. It could either leave illegal characters alone or it could throw an `IllegalArgumentException`. Which approach the decoder takes is left to the implementation.

  Since:
    1.2

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `URLDecoder()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static String` | `decode(String s)` Deprecated. The resulting string may vary depending on the platform's default encoding. Instead, use the decode(String,String) method to specify the encoding.
    `static String` | `decode(String s, String enc)` Decodes a `application/x-www-form-urlencoded` string using a specific encoding scheme.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### URLDecoder

          public URLDecoder()

  - ### Method Detail

    - #### decode

          @Deprecated
          public static String decode(String s)

      Deprecated. The resulting string may vary depending on the platform's default encoding. Instead, use the decode(String,String) method to specify the encoding.
      Decodes a `x-www-form-urlencoded` string. The platform's default encoding is used to determine what characters are represented by any consecutive sequences of the form "`%xy`".
      Parameters:
        `s` - the `String` to decode
      Returns:
        the newly decoded `String`

    - #### decode

          public static String decode(String s,
                                      String enc)
                               throws UnsupportedEncodingException

      Decodes a `application/x-www-form-urlencoded` string using a specific encoding scheme. The supplied encoding is used to determine what characters are represented by any consecutive sequences of the form "`%xy`".

      Note: The World Wide Web Consortium Recommendation states that UTF-8 should be used. Not doing so may introduce incompatibilities.

      Parameters:
        `s` - the `String` to decode
        `enc` - The name of a supported character encoding.
      Returns:
        the newly decoded `String`
      Throws:
        `UnsupportedEncodingException` - If character encoding needs to be consulted, but named character encoding is not supported
      Since:
        1.4
      See Also:
        `URLEncoder.encode(java.lang.String, java.lang.String)`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2016, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.